package CalculiX;

class EFunApp extends Expression {

  // The primitive function.
  final String f;
  // The argument.
  final Expression e;

  EFunApp (String f, Expression e)
  {
    this.f = f;
    this.e = e;
  }

  public Value eval (Environment env) throws EvalException
  {
    // Evaluate the operand.
    Value v = e.eval(env);
    // Make sure that it produces a double result.
    double x = v.asDouble();
    // Perform the appropriate operation.
    double d;
    if (f.equals("abs"))
      d = Math.abs(x);
    else if (f.equals("acos"))
      d = Math.acos(x);
    else if (f.equals("asin"))
      d = Math.asin(x);
    else if (f.equals("atan"))
      d = Math.atan(x);
    else if (f.equals("cbrt"))
      d = Math.cbrt(x);
    else if (f.equals("ceil"))
      d = Math.ceil(x);
    else if (f.equals("cos"))
      d = Math.cos(x);
    else if (f.equals("cosh"))
      d = Math.cosh(x);
    else if (f.equals("exp"))
      d = Math.exp(x);
    else if (f.equals("floor"))
      d = Math.floor(x);
    else if (f.equals("log"))
      d = Math.log(x);
    else if (f.equals("sin"))
      d = Math.sin(x);
    else if (f.equals("sinh"))
      d = Math.sinh(x);
    else if (f.equals("sqrt"))
      d = Math.sqrt(x);
    else if (f.equals("tan"))
      d = Math.tan(x);
    else if (f.equals("tanh"))
      d = Math.tanh(x);
    else
      throw new EvalException ("Unknown mathematical function: " + f);
    // Package up the result as a value.
    return new VDouble (d);
  }

}
